#pragma once
#ifndef TRIANGLE_H
#define TRIANGLE_H

#include <QDebug>
#include <QVector>
#include "vertex.h"

class Triangle {
    public:
        Triangle();
        Triangle(const Triangle &other);
        Triangle(const QVector<Vertex> &vertex_buffer, int u, int v, int w);

        Vertex u() const;
        Vertex v() const;
        Vertex w() const;

        int u_idx() const;
        int v_idx() const;
        int w_idx() const;

        Triangle &operator=(const Triangle &other);

    private:
        QVector<Vertex> vertex_buffer_;
        int u_;
        int v_;
        int w_;
};

QDebug operator<<(QDebug d, const Triangle &triangle);

#endif
